=== requirements.txt ===
black==24.8.0
cmakelang==0.6.13
isort==5.13.2
pexpect==4.9.0
pygments==2.18.0
pylint==3.2.6
pytest==8.3.3
